给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。
你可以按任意顺序返回答案。
示例 1:
输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1]
示例 2:
输入:nums = [3,2,4], target = 6
输出:[1,2]
示例 3:
输入:nums = [3,3], target = 6
输出:[0,1]
来源:力扣(LeetCode)
链接:leetcode-cn.com/problems/tw…
1、暴力解法:for for
var twoSum = function(nums, target) { const length = nums.length for(let i = 0;i < length; i++) { for(let j = i + 1;j < length + 1;j++) { if (nums[i] + nums[j] == target) { return [i, j] } } }};
2、动态哈希表算法 --推荐
var twoSum = function(nums, target) { const hashMap = new Map() // 第一项前无相加项,故先存入哈希表 hashMap.set(nums[0], 0) const length = nums.length for (let i = 1; i < length; i++) { let otherNums = target - nums[i] // 获取 if (hashMap.get(otherNums) != undefined) return [hashMap.get(otherNums), i] hashMap.set(nums[i], i) // 不匹配的存入哈希表 }};